# Allow domain access Source: https://developer.box.com/guides/api-calls/allowing-domain-access To use the Box APIs it is important that your application and users have access to the following domains, where needed. ## File preview To enable file preview, your application might need to load javascript file from the Box content delivery network (CDN). This file is loaded from the following domains. * `api.box.com` * `boxcdn.net` * `boxcloud.com` * `dl2.boxcloud.com` to `dl20.boxcloud.com` ## File downloads The following API domains are used to download files via the Box API. * `api.box.com` to initially request a file to download * `dl.boxcloud.com` to actually download files for authenticated users * `public.boxcloud.com` to actually download files for unauthenticated users Ensuring access to these domains is only a first step to downloading a file. To download a file the users need to have proper access permissions and need to be fully authenticated where needed. ## File uploads The following API domains are used to upload files via the Box API. * `api.box.com` to start a file upload * `upload.app.box.com` and `upload.box.com` to upload the file to Box # API versioning strategy Source: https://developer.box.com/guides/api-calls/api-versioning-strategy Box provides versioning capabilities for selected API endpoints. The version control system guarantees seamless functioning of existing endpoint versions, even if Box introduces new ones. API versioning empowers Box to continually enhance its platform, while also offering third-party developers a reliable avenue for feature updates and deprecations. To stay informed about the forthcoming API modifications, monitor the Changelog and maintain a current email address in the Developer Console's App Info section. In 2024, Box introduced year-based API versioning. All endpoints available at the end of 2024 were assigned the version `2024.0`. **No action is required for API users to continue using Box APIs.** To make version-aware API calls, include the `box-version` header with the value `2024.0` in your requests. ## How Box API versioning works Box API supports versioning in `header`. To determine which version to use, look at the API reference and included sample requests. ### Versioning in `header` Box API processes the `box-version` header which should contain a valid version name. For example, when a client wants to get a list of all sign requests using version `2025.0`, the request should look like this: ```sh theme={null} curl --location 'https://api.box.com/2.0/sign_requests' \ --header 'box-version: 2025.0' \ --header 'Authorization: Bearer … ``` If the provided version is correct and supported by the endpoint, a response is sent to the client. If the endpoint is available in multiple versions, the response will include the `box-version` header, which indicates the version used to handle the request. Endpoints introduced after 2024 may return a `400` error code if the version is incorrect. More information about versioning errors can be found here. If your request doesn't include a version, the API defaults to the initial Box API version - `2024.0` - the version of endpoints available before year-based versioning was introduced. However, relying on this behavior is not recommended when adopting deprecated changes. To ensure consistency, always specify the API version, with each request. By making your application version-aware, you anchor it to a specific set of features, ensuring consistent behavior throughout the supported timeframe. ## Release schedule and naming convention Box can introduce a new breaking change to certain endpoints **once per year**, which results in a new API version. Introducing a new version of the Sign Request endpoint means that **all paths and HTTP methods** of an endpoint will support it. For example, if Sign Request endpoints receive a new version it will apply to all endpoints listed in the table: | Method | Request URL | Description | | - | - | - | | GET | `https://api.box.com/2.0/sign_requests/:id` | Retrieves specific sign request details. | | GET | `https://api.box.com/2.0/sign_requests/` | Retrieves all sign requests. | | POST | `https://api.box.com/2.0/sign_requests/` | Creates new sign requests. | | POST | `https://api.box.com/2.0/sign_requests/:id/resend` | Sends a specific sign request again. | | POST | `https://api.box.com/2.0/sign_requests/:id/cancel` | Cancels a specific sign request. | ### Naming convention New API versions are labeled according to the calendar year of their release. **Example**: If a new version of the Sign Requests endpoint is released in 2025, it will be named `2025.0`. Box can issue a new breaking change to API endpoints **once** per year, reserving the right to release an additional breaking change to address security or privacy concerns. In such cases, the new version will be incremented by one in the suffix. **Example**: If security issues need addressing in the previously released version `2025.0` of Sign Requests, the new version will be labeled `2025.1`. Each stable version is supported for a minimum of 12 months. This means that when a new version is released, the previous version becomes deprecated and will be available for use, but no new features will be added. It also means that a new version cannot be released sooner than every 12 months. We strongly recommend updating your apps to make requests to the latest stable API version. However, if your app uses a stable version that is no longer supported, then you will get a response with an HTTP error code `400 - Bad Request`. For details, see Versioning Errors. ### Endpoint versioning indication To keep you informed about the current API state, and improve the readability of the versioned API reference, the affected endpoints are marked with a pill based on the `x-stability-level` tag or `deprecated` attribute. An example of a beta pill used for API reference endpoints | Schema element | Pill name | Description | | - | - | - | | `x-stability-level: beta` | Beta | Endpoints marked with **beta**, are offered subject to Box’s Main Beta Agreement, meaning the available capabilities may change at any time. When the beta endpoint becomes stable, the **beta** indication is removed. | | `x-stability-level: stable` or no `x-stability-level` tag | Latest version | **Latest version** marks the most recent stable API version of an endpoint. | | `deprecated: true` | Deprecated | An endpoint is deprecated, which means it is still available for use, but no new features are added. Such an endpoint is annotated with the `deprecated` attribute set to `true`. | ## Versioning errors When using versioned API actions such as calling an incorrect API version in header or a deprecated version can lead to errors. For details on possible errors, see versioning errors. ## How Box SDK versioning works The versioning strategy applies only to [generated SDKs](/sdks-and-tools/#next-generation-sdks). Box SDKs support the **All Versions In** SDK approach. This means that every release of SDK provides access to all endpoints in any version which is currently live. All generated SDKs use manager's approach - they group all endpoints with the same domain in one manager. For example `FolderManager` contains methods to: `create_folder`, `get_folder_by_id`, `update_folder_by_id`, `delete_folder_by_id`, `get_folder_items` and `copy_folder`. This division is done based on the value of `x-box-tag` field, which is assigned to each method in Public API Service specification. It mostly corresponds to the root of the endpoint URL, but not necessarily. For example: `FolderManager` contains methods with `https://api.box.com/2.0/folders` root URL, but the same base URL is also used in some methods of `SharedLinkFoldersManager`. References to all managers are stored under one Box Client object. See an example of the endpoint's lifecycle: 1. Initial state (only one version is available). ```js theme={null} class FilesManager { async updateFileById( fileId: string, requestBody: UpdateFileByIdRequestBody, queryParams: UpdateFileByIdQueryParams, headers: UpdateFileByIdHeaders ): Promise < FileFull > {} } ``` 2. A new `v2025_0` version of the endpoint is introduced (previous version is deprecated). The SDK introduces a new method for each new version of an endpoint. These methods are stored in the same manager as the old ones, but their names and corresponding classes are suffixed with the version number. The old method is deprecated with a notice indicating the minimal maintenance date – this will be the date when the endpoint will be considered for end-of-life status. ```js theme={null} class FilesManager { /** * @deprecated This endpoint will be EOL'ed after 05-2026. */ async updateFileById( fileId: string, requestBody: UpdateFileByIdRequestBody, queryParams: UpdateFileByIdQueryParams, headers: UpdateFileByIdHeaders ): Promise {} async updateFileById_2025_0( fileId: string, requestBody: UpdateFileByIdRequestBody_2025_0, queryParams: UpdateFileByIdQueryParams_2025_0, headers: UpdateFileByIdHeaders_2025_0 ): Promise {} } ``` 3. The API endpoint is marked as End-of-Life (EOL) The SDK releases a breaking change release with removed end-of-life (EOL) endpoints. Ideally, we should group the end-of-life dates for all endpoints into one date per quarter to avoid releasing numerous new major versions of SDKs. ```js theme={null} class FilesManager { async updateFileById_2025_0( fileId: string, requestBody: UpdateFileByIdRequestBody_2025_0, queryParams: UpdateFileByIdQueryParams_2025_0, headers: UpdateFileByIdHeaders_2025_0 ): Promise < FileFull_2025_0 > {} } ``` ## Breaking vs non-breaking changes Breaking changes in the Box API occur within versioned releases, typically accompanied by a new major API version. Minor adjustments, which do not disrupt existing functionality, can be integrated into an existing API version. The following table lists both breaking and non-breaking changes. | API Change | Breaking change | | - | - | | New endpoints | No | | New [read-only](https://swagger.io/docs/specification/data-models/data-types/) or optional fields in request | No | | New required fields in request | Yes | | New string constant in request | Yes | | Deprecation | No | | Retired / End-of-Life endpoints | Yes | | Rename/reshape of a field, data type, or string constant | Yes | | More restrictive change to field validations | Yes | | Less restrictive change to field validations | No | | Changing HTTP status code returned by an operation | Yes | | Removing a declared property | Yes | | Removing or renaming APIs or API parameters | Yes | | Adding a required request header | Yes | | Adding more error codes | No | | Removing or modifying error codes | Yes | | Adding a member to an enumeration | Yes | The [oasdiff](https://github.com/Tufin/oasdiff) tool allows detecting most of the possible breaking changes. ## Forward compatibility of API responses Box may add new, optional, or read-only fields to API responses at any time without a version bump. These changes are considered non-breaking and require no advance notification. Client applications must be implemented to tolerate additional JSON fields and ignore fields they do not recognize. Strict response schema validation or deserialization that rejects unknown fields is discouraged, as it may cause integrations to break when Box introduces new fields. To ensure long-term stability: * Integrate only the documented fields your application explicitly requires * Do not assume API responses will exactly match a fixed schema * Configure JSON parsing libraries to ignore unmapped or unexpected properties ## AI agent configuration versioning AI agent versioning gives the developers more control over model version management and ensures consistent responses. For details, see AI agent configuration versioning guide. ## Support policy and deprecation information When new versions of the Box APIs and Box SDKs are released, earlier versions will be retired. Box marks a version as `deprecated` at least 24 months before retiring it. In other words, a deprecated version cannot become end-of-life sooner than after 24 months. Similarly, for individual APIs that are generally available (GA), Box declares an API as `deprecated` at least 24 months in advance of removing it from the GA version. When we increment the major version of the API (for example, from `2025.0` to `2026.0`), we're announcing that the current version (in this example, `2025.0`) is immediately deprecated and we'll no longer support it 24 months after the announcement. We might make exceptions to this policy for service security or health reliability issues. When an API is marked as deprecated, we strongly recommend that you migrate to the latest version as soon as possible. In some cases, we'll announce that new applications will have to start using the new APIs a short time after the original APIs are deprecated. When customer calls deprecated API endpoint, the response will contain a header: ```sh theme={null} Deprecation: date="Fri, 11 Nov 2026 23:59:59 GMT" Box-API-Deprecated-Reason: /reference/deprecated ``` The date tells clients when this version was marked as deprecated. ## Versioning considerations When building your request, consider the following: * Endpoints in version `2024.0` can be called without specifying the version in the `box-version` header. If no version is specified and the `2024.0` version of the called endpoint does not exist, the response will return an HTTP error code `400 - Bad Request`. * If the `box-version` version header is specified but the requested version does not exist, the response will return an HTTP error code `400 - Bad Request`. For details, see versioning errors. When Box deprecates a resource or a property of a resource in the API, the change is communicated in one or more of the following ways: * Calls that include the deprecated behavior return the response header `Box-API-Deprecated-Reason` and a link to get more information: ```sh theme={null} box-version: 2025.0 Deprecation: version="version", date="date" Box-API-Deprecated-Reason: /reference/deprecated ``` * A deprecation announcement is posted in the developer changelog. * The API reference is updated to identify the affected resource and any action you need to take. Affected endpoints are marked with **deprecated** pill. * If there is an imminent backwards-incompatible change that affects your app, then the contact email for your app might be contacted about the deprecation. ## Additional resources * API reference # Ensure consistency with headers Source: https://developer.box.com/guides/api-calls/ensure-consistency Some Box APIs support headers used to ensure consistency between your application and Box. ## `etag`, `if-match`, and `if-none-match` Many of the file system items (files or folders) that can be requested via the API return an `etag` value for the item. For example, a file resource returns an `etag` in the JSON response. ```sh theme={null} curl https://api.box.com/2.0/files/12345 \ -H "authorization: Bearer ACCESS_TOKEN" ``` ```json theme={null} { "id": 12345, "etag": 1, "type": "file", "sequence_id": 3, "name": "Contract.pdf", ... } ``` This `etag` can be used as the value of an `if-match` or `if-none-match` header to either ensure a resource hasn't changed since the `etag` value was received, or to prevent unnecessary downloads for items that haven't changed. For example, to fetch the same file only if it has changed, pass in the `etag` value in an `if-none-match` header. ```sh theme={null} curl https://api.box.com/2.0/files/12345 \ -H "authorization: Bearer ACCESS_TOKEN" \ -H "if-none-match: 1" ``` This API call would result in an empty response if the file had not changed. ## Ensure consistent changes The `if-match` header allows your application to ensure that no changes are made to items when another application or a user has made changes to the item since your application last inspected it. This helps ensure that changes aren't lost when two applications or users are changing items at the same time. The following endpoints support this header. | `if-match` capable endpoints | | | - | - | | `POST /files/:id/content` | Upload a new file version | | `PUT /files/:id` | Update a file's information | | `DELETE /files/:id` | Delete a file | | `PUT /folders/:id` | Update a folder's information | | `DELETE /folders/:id` | Delete a folder | | `PUT /web_links/:id` | Update a web link's information | | `DELETE /web_links/:id` | Delete a web link | The response of these API calls depends on the existence of the item, and whether the `etag` value matches the most recent version. | Item found? | Etag match? | HTTP status | | - | - | - | | Yes | Yes | 200 | | Yes | No | 412 | | No | Yes | 412 | | No | No | 404 | **Moving items** The `if-match` header cannot be used to prevent moving of files, folders, or web links. Instead, Box always ensures that the latest item is moved to the new location. ## Prevent unnecessary request downloads The `if-none-match` header allows your application to ensure that no information is downloaded for items that have not changed since your application last inspected it. This helps ensure no unnecessary information is downloaded, speeding up your application and saving on bandwidth. | `if-none-match` capable endpoints | | | - | - | | `GET /files/:id` | Get a file's information | | `GET /folders/:id` | Get a folder's information | | `GET /web_links/:id` | Get a web link's information | | `GET /shared_items` | Get a shared item's information | The response of these API calls depends on the existence of the item, and whether the `etag` value matches the most recent version. | Item found? | Etag match? | HTTP Status | | - | - | - | | Yes | Yes | 304 | | Yes | No | 200 | | No | Yes | 404 | | No | No | 404 | # API Calls Source: https://developer.box.com/guides/api-calls/index Learn how to make calls to the Box REST API, including authentication headers, common patterns, and platform insights. The Box API is a restful API that follows common HTTP standards where possible. The following guides take a look at some of the useful features and common mistakes that a developer can encounter when working with these APIs. ## Quick example Every API call requires an access token in the `Authorization` header. This example retrieves the current user's profile: ```bash theme={null} curl https://api.box.com/2.0/users/me \ -H "Authorization: Bearer ACCESS_TOKEN" ``` ## API calls insights Admins and co-admins can access the Platform Insights dashboard that provides information on the total number of API calls per application. See [Platform Insights][insights] and applications for details. [insights]: https://support.box.com/hc/en-us/articles/20738406915219-Platform-Insights # Language codes Source: https://developer.box.com/guides/api-calls/language-codes The Box API uses a modified version of the **ISO 639-1 Language Code** to specify a user's language. The following is a list of language codes used when creating or updating. | Language | Code | | - | - | | Bengali | `bn` | | Danish | `da` | | German | `de` | | English (US) | `en` | | English (UK) | `gb` | | English (Canada) | `e2` | | English (Australia) | `e3` | | Spanish (Latin America) | `s2` | | Spanish | `es` | | Finnish | `fi` | | French | `fr` | | French (Canada) | `f2` | | Hindi | `hi` | | Italian | `it` | | Japanese | `ja` | | Korean | `ko` | | Norwegian (Bokmal) | `nb` | | Dutch | `nl` | | Polish | `pl` | | Portuguese | `pt` | | Russian | `ru` | | Swedish | `sv` | | Turkish | `tr` | | Chinese (Simplified) | `zh` | | Chinese (Traditional) | `zt` | # Pagination overview Source: https://developer.box.com/guides/api-calls/pagination/index The Box API supports two ways to paginate collections. The most common way to paginate is through offset-based pagination which is often used where the list of items is of a fixed, predetermined length. In some cases an API endpoint supports marker-based pagination, either as an alternative to offset-based pagination or as a full replacement. Marker-based pagination is often used in cases where the length of the total set of items is either changing frequently, or where the total length might not be known upfront. # Marker-based Pagination Source: https://developer.box.com/guides/api-calls/pagination/marker-based APIs that use marker-based paging use the `marker` and `limit` query parameters to paginate through items in a collection. Marker-based pagination is often used in cases where the length of the total set of items is either changing frequently, or where the total length might not be known upfront. ## Paging To fetch the first page of entries in a collection the API needs to be called either without the `marker` parameter, or with the `marker` set to `0`. The `limit` parameter is optional. ```sh theme={null} curl https://api.box.com/2.0/folders/0/items?limit=100&usemarker=true&marker= \ -H "authorization: Bearer ACCESS_TOKEN" ``` APIs that support both offset-based pagination and marker-based pagination require the `usemarker` query parameter to be set to `true` to ensure marker-based pagination is used. To fetch the next page of entries the API needs to be called with a `marker` parameter that equals the value of the `next_marker` value that was received in the API response. ```sh theme={null} curl https://api.box.com/2.0/folders/0/items?marker=34332423&limit=100&usemarker=true \ -H "authorization: Bearer ACCESS_TOKEN" ``` The final page of items has been requested when the next `next_marker` value is `null` in the response object. At this point there are no more items to fetch. With marker-based paging there is no way to determine the total number of entries in a collection except by fetching them all. Applications should not retain the `next_marker` value long-term as the internal implementation of the markers may change over time. ## Marker & Limit The following query parameters are used to paginate a collection. | Query parameter | Type | Default | | | - | - | - | - | | `marker` | String | | The first position in the collection to return results from. This should be a value that was returned in a previous request. | | `limit` | Integer | Depends on API | The maximum number of entries to return. If the value exceeds the maximum, then the maximum value will be used. | | `usemarker` | Boolean | | An optional query parameter that can be used with API endpoints that support both types of pagination to select pagination type. Set to `true` to enforce marker-based pagination. | ## Collections When paginating collections, the API returns an object that contains the set of results as an array, as well as some information about the current page of results. | Field | Type | | | - | - | - | | `entries` | Array | The page of items for this page. This will be an empty array if there are no results. | | `next_marker` | String | The value that can be used as the `marker` value to fetch the next page of results. If this value is `null` or an empty string there are no more results to fetch. | | `limit` | Integer | The limit used for this page of results. This will be the same as the `limit` query parameter unless it exceeded the maximum value allowed for this API endpoint. | ## Example endpoints Some endpoints that support marker-based pagination are: * List items for a folder * List a file's collaborations * List all webhooks for a user * List all users in an enterprise * List all items in the trash # Box API offset-based pagination Source: https://developer.box.com/guides/api-calls/pagination/offset-based Page Box API collections with `offset` and `limit`. This includes limits of offset-based pagination, and when to use marker-based paging instead. APIs that use offset-based paging use the `offset` and `limit` query parameters to paginate through items in a collection. Offset-based pagination is often used where the list of items is of a fixed and predetermined length. ## Paging To fetch the first page of entries in a collection the API needs to be called either without the `offset` parameter, or with the `offset` set to `0`. The `limit` field is optional. ```sh theme={null} curl https://api.box.com/2.0/folders/0/items?offset=0&limit=100 \ -H "authorization: Bearer ACCESS_TOKEN" ``` To fetch the next page of entries the API needs to be called with an `offset` parameter that equals the sum of the previous `offset` value and limit returned in the previous result, `previous_offset + previous_limit`. ```sh theme={null} curl https://api.box.com/2.0/folders/0/items?offset=100&limit=100 \ -H "authorization: Bearer ACCESS_TOKEN" ``` Note that the `offset` should be increased by the previous `limit` and not by the size of the entries in the response array, as this may be less than the limit. Generally we advise using the value of the `limit` in the response object to increase the `offset` value. The final page of items has been requested when the next `offset` value exceeds the `total_count` value in the response object. At this point there are no more items to fetch. ## Offset & Limit The following query parameters are used to paginate a collection. | Query parameter | Type | Default | | | - | - | - | - | | `offset` | Integer | `0` | The (zero-based) offset of the first item returned in the collection. In a zero-based offset `0` is a correct value. | | `limit` | Integer | Depends on API | The maximum number of entries to return. If the value exceeds the maximum, then the maximum value will be used. | The maximum `offset` for offset-based pagination is `9999`. Marker-based pagination is recommended when a higher offset is needed. ## Collections When paginating collections, the API returns an object that contains the set of results as an array, as well as some information about the current page of results. | Field | Type | | | - | - | - | | `entries` | Array | The page of items for this page. This will be an empty array if there are no results. | | `offset` | Integer | The offset used for this page of results | | `limit` | Integer | The limit used for this page of results. This will be the same as the `limit` query parameter unless it exceeded the maximum value allowed for this API endpoint. | | `total_count` | Integer | One greater than the offset of the last item in the entire collection. The total number of items in the collection may be less than `total_count`. | ## Example endpoints Some endpoints that support offset-based pagination are: * List items for a folder * List a file's comments * List all items in the trash # Box API errors Source: https://developer.box.com/guides/api-calls/permissions-and-errors/common-errors Look up Box API HTTP errors, JSON error responses, and common 4xx and 5xx codes when a request fails. The Box API uses [HTTP status codes][status-codes] to communicate whether a request was processed successfully. Working through API errors? A free developer account gives you access to the Developer Console, where you can test API calls and debug with your own applications. ## Client error Most client errors in the HTTP 4XX range, and some server errors in the HTTP 5XX range, return a standard client error JSON object. ```json theme={null} { "type": "error", "status": 400, "code": "bad_digest", "help_url": "/guides/api-calls/permissions-and-errors/common-errors/", "message": "The specified content-md5 did not match what we received", "request_id": "abcdef123456" } ``` See the Client Error resource for more details. ## Common error codes Check our [Developer Troubleshooting Articles][articles] for solutions to common errors encountered when working with the Box APIs. ### 400 Bad Request | | | | - | - | | **Error** | `bad_digest` | | **Message** | The specified `content-md5` did not match what we received. | | **Solution** | While uploading a file, a `content-md5` header with the SHA-1 hash of the file can be supplied to ensure that the file is not corrupted in transit. The SHA-1 hash that was supplied in the request did not match what was received in the upload. Supply a valid SHA-1 hash of the uploaded file. | | | | | - | - | | **Error** | `bad_request` | | **Message** | | | **Solution** | Required parameters supplied in the API request are either missing or invalid. Check the extended error message in the response body for more details. | | | | | - | - | | **Error** | `cannot_make_collaborated_subfolder_private` | | **Message** | Cannot move a collaborated subfolder to a private folder unless `owned_by.id` matches the requestor’s user ID. | | **Solution** | Set the `owned_by.id` field to the user ID of the API requestor when moving a collaborated subfolder into a private folder. | | | | | - | - | | **Error** | `collaborations_not_available_on_root_folder` | | **Message** | Root folder cannot be collaborated | | **Solution** | You cannot set collaborators on a user's root folder (folder ID 0). Use a different folder ID than the root folder. | | | | | - | - | | **Error** | `cyclical_folder_structure` | | **Message** | Folder move creates cyclical folder structure | | **Solution** | The folder ID specified in the folder move would create a cyclical folder structure (for example moving a folder to a subfolder within itself). Change the folder ID for the folder move request. | | | | | - | - | | **Error** | `folder_not_empty` | | **Message** | Cannot delete – folder not empty | | **Solution** | Delete all content from the folder before attempting to delete it. | | | | | **Error** | `invalid_collaboration_item` | | **Message** | Item type must be specified and set to 'folder' | | **Solution** | Set the `item.type` field of the collaboration item to `folder`. | | | | | - | - | | **Error** | `invalid_client` | | **Message** | The client credentials are invalid. | | **Solution** | Verify the `client_id` and `client_secret` in the token request match the values in the Developer Console. | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | Verify the authorization code is set correctly in your request, or your application likely needs to get a new authorization code. | | **Solution** | The authorization code supplied in the API request is missing or no longer valid. Possible solutions are to verify that the access token is added correctly in the request. If correctly set, the access token might have expired. Attempt to refresh the access token or fetch a new one. | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | Current date time must be before the expiration date time listed in the `exp` claim. | | **Solution** | This error occurs when the Unix time on your local machine and the Box server are out of sync. To fix this error, update the Unix time on your machine to match a synchronized time server, then try the request again. | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | Invalid refresh token. | | **Solution** | The refresh token might be invalid, revoked, or expired. Correct your application's refresh token handling and obtain a new token pair through the OAuth 2.0 authorization flow if needed. | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | The authorization code has expired. | | **Solution** | Authorization codes expire shortly after they are issued (on the order of tens of seconds). Exchange the code for tokens immediately after the user is redirected back to your application. | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | Please check the `sub` claim. | | **Solution** | For JWT authentication, set the `sub` (subject) claim to the correct user ID or enterprise ID depending on `box_sub_type`. More information is available on our [support site](https://support.box.com/hc/en-us/articles/360043691734). | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | Please check the `jti` claim. A unique `jti` value is required. | | **Solution** | Ensure the JWT ID (`jti`) is set to a valid, unique value for each assertion. The same `jti` cannot be reused. | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | Please check the `iss` claim. | | **Solution** | The issuer (`iss`) claim must match the OAuth client ID for your application when using JWT authentication. | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | Signature verification error. The public key identified by `kid` must correspond to the private key used for signing. | | **Solution** | Use the public/private keypair associated with your app in the Developer Console. If you rotate keys, add the new key, remove the old one, update your configuration file with the new keypair and `kid`, then request a new access token. | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | `kid` invalid, unable to lookup correct key. | | **Solution** | The key ID (`kid`) in the JWT header must match a public key registered for the application (for example, the `publicKeyID` in your configuration). Confirm you are using the correct configuration file, or generate a new RSA keypair in the Developer Console and update your app to use it. | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | App is not yet authorized for use. | | **Solution** | The server authentication app (JWT or Client Credentials Grant) has not been authorized for use in your enterprise. Check the authorization status in the right-side panel on the app's **Configuration** tab. See [Platform app approval](/guides/authorization/platform-app-approval). | | | | | - | - | | **Error** | `invalid_grant` | | **Message** | Cannot obtain user token based on the enterprise configuration for your app. | | **Solution** | You are requesting a user token (for example, CCG with `box_subject_type=user`, or the `as-user` header) but the app is not configured to issue one. On the app's **Configuration** tab, enable **Generate User Access Tokens** under **Advanced Features**, set **App Access Level** to **App + Enterprise Access** if you are authenticating as a Managed User or Admin, then have an admin re-authorize the app. See [Client Credentials Grant](/guides/authentication/client-credentials). | | | | | - | - | | **Error** | `invalid_limit` | | **Message** | Limit is not a valid number | | **Solution** | Add a valid numeric value for the supplied limit value. | | | | | **Error** | `invalid_offset` | | **Message** | Offset is not a valid number | | **Solution** | Add a valid numeric value for the supplied offset value. | | | | | **Error** | `invalid_request` | | **Message** | The grant type is unauthorized for this client\_id. | | **Solution** | You might be requesting a token using standard OAuth 2.0 while the app is configured for Server Authentication (JWT), or the other way around. Use the token request type that matches your app's authentication method. See [The grant type is unauthorized for this client\_id](https://support.box.com/hc/en-us/articles/360044193033-API-Authentication-The-grant-type-is-unauthorized-for-this-client-id). | | | | | - | - | | **Error** | `invalid_request` | | **Message** | Invalid `grant_type` parameter or parameter missing. | | **Solution** | You might be sending token requests to the wrong domain (such as `app.box.com` or `www.box.com`). Send token requests to `https://api.box.com`. Use the `grant_type` and other parameters required for your flow (`authorization_code`, `refresh_token`, [JWT assertion](/reference/post-oauth2-token#body-grant-type), and so on). | | | | | - | - | | **Error** | `invalid_request` | | **Message** | Cannot obtain user token based on the enterprise configuration for your app. | | **Solution** | Your app might be missing a scope or configuration needed to request a user token. See [Cannot Obtain Token Based on Enterprise Configuration for Your App](https://support.box.com/hc/en-us/articles/360044192553). | | | | | - | - | | **Error** | `invalid_request_parameters` | | **Message** | Invalid input parameters in request | | **Solution** | Invalid parameters were sent in the API request. Check the API reference documentation for the correct request parameters that should be supplied for the API operation. | | | | | - | - | | **Error** | `invalid_status` | | **Message** | You can change the status only if the collaboration is pending | | **Solution** | The status of a collaboration can only be updated to accepted or rejected by the user specified in the `accessible_by` field when the current status is set to pending. | | | | | - | - | | **Error** | `invalid_upload_session_id` | | **Message** | The upload session ID provided in the URL is not of a valid format. | | **Solution** | The session ID supplied when making a chunked upload API request was invalid. Use the same session ID from the session that was created. | | | | | | - | - | - | | **Error** | `item_name_invalid` | | | **Message** | Item name invalid | | | **Solution** | Verify that the file's name is valid. Box only supports file or folder names that are 255 characters or less. File names containing non-printable characters, names containing the characters `/`, `\`, `<`, `>`, `:`, \` | `, `?`, `\*`, `-\`, names with leading or trailing spaces, and the special names "." and ".." are also unsupported. | | | | | - | - | | **Error** | `item_name_too_long` | | **Message** | Item name too long | | **Solution** | Shorten the length of the name that is being supplied for the item. The maximum length of a file or folder name in Box is 255 characters or less. | | | | | - | - | | **Error** | `metadata_after_file_contents` | | **Message** | Metadata is included after file contents in a file upload request. | | **Solution** | Include the file metadata before the file's contents. | | | | | **Error** | `password_reset_required` | | **Message** | User needs to reset password | | **Solution** | The user has not yet completed account [setup steps](https://support.box.com/hc/en-us/articles/360043691614). | | | | | **Error** | `requested_page_out_of_range` | | **Message** | Requested representation page out of range | | **Solution** | The range header supplied does not fit within the size of the specified item. Adjust the bounds to fit within the size of the item and try again. | | | | | - | - | | **Error** | `requested_preview_unavailable` | | **Message** | Requested preview unavailable | | **Solution** | The thumbnail size requested for the file is not valid. See the reference docs for the API operation for available format sizes. | | | | | - | - | | **Error** | `sync_item_move_failure` | | **Message** | Cannot move a synced item | | **Solution** | The item is set to be synced by the Box sync clients and cannot be moved. A possible solution is to set the `sync_state` of the item to `not_synced`. | | | | | - | - | | **Error** | `task_assignee_not_allowed` | | **Message** | Assigner does not have sufficient privileges to assign task to assignee | | **Solution** | The user who is attempting to assign the task does not have the appropriate permissions to do so. Adjust the user permissions to allow the assignment of tasks. | | | | | - | - | | **Error** | `terms_of_service_required` | | **Message** | User must accept custom terms of service before action can be taken | | **Solution** | The user in context for the API request has not accepted the enterprise's custom Terms of Service. For login-capable managed users, acceptance is required before most API calls, user access token issuance, or OAuth authorization can proceed. Service accounts and App Users are exempt. If you are using server authentication with the `As-User` header or a user access token, the impersonated or token subject user must have accepted. The user can accept via the Box web application, or your application can accept programmatically using the Terms of Service application flow. For more information, see [Using custom Terms of Service](https://support.box.com/hc/en-us/articles/360044192733-Using-Custom-Terms-Of-Service). | | | | | - | - | | **Error** | `unauthorized_client` | | **Message** | This app is not authorized by the enterprise admin. | | **Solution** | Server authentication applications using JWT or Client Credentials Grant must be authorized by a Box Admin before use. Follow the steps in Platform app approval. | | | | | - | - | | **Error** | `user_already_collaborator` | | **Message** | User is already a collaborator | | **Solution** | The user you are trying to add as a collaborator is already a collaborator on that item. You don't need to send this request. | ### 401 Unauthorized | | | | - | - | | **Error** | `unauthorized` | | **Message** | Unauthorized | | **Solution** | Authorization token is not authorized, check extended error message in body for more details. | | | | | - | - | | **Error** | `invalid_token` | | **Message** | The access token provided is invalid. | | **Solution** | The access token might be incorrect, corrupted, or expired – for example, because of a typo, using a token from another environment, or revocation or deletion. Obtain a new access token from the token endpoint. For OAuth 2.0 authentication, you can refresh an expired access token. See Refresh a token. | ### 403 Forbidden | | | | - | - | | **Error** | `access_denied_insufficient_permissions` | | **Message** | Access denied – insufficient permission | | **Solution** | The access token does not have the appropriate user permissions or scopes. For solutions, see [403 access denied insufficient permissions errors](https://support.box.com/hc/en-us/articles/360043693434-API-Content-API-403-access-denied-insufficient-permissions-Errors). | | | | | - | - | | **Error** | `insufficient_scope` | | **Message** | The request requires higher privileges than provided by the access token. | | **Solution** | This error is typically produced when scopes that are needed for the API operation are not enabled. Check your configured application scopes and reauthorize your application, if applicable. | | | | | - | - | | **Error** | `access_denied_item_locked` | | **Message** | Access denied – item locked | | **Solution** | You are attempting to access a locked item without appropriate permissions to access it. Unlock the item first, then try to access it again. | | | | | - | - | | **Error** | `access_from_location_blocked` | | **Message** | | | **Solution** | You're attempting to log in to Box from a location that has not been approved by your admin. Talk to your admin to resolve this issue. | | | | | - | - | | **Error** | `file_size_limit_exceeded` | | **Message** | File size exceeds the folder owner’s file size limit | | **Solution** | For limits based on account type, see [Understand the maximum file size you can upload](https://support.box.com/hc/en-us/articles/360043697314-Understand-the-Maximum-File-Size-You-Can-Upload-to-Box). | | | | | **Error** | `forbidden` | | **Message** | | | **Solution** | Client does not have permission to upload to this session. Only the user who initiated the upload session may upload to it. | | | | | - | - | | **Error** | `forbidden_by_policy` | | **Message** | Access denied – Blocked by Shield Access Policy | | **Solution** | Shield access policies applied on your enterprise have prevented this action. Contact your enterprise admin to adjust the applied Shield access policies. | | | | | - | - | | **Error** | `forbidden_by_policy` | | **Message** | Access denied – Blocked by Shield Malware Detection Rule | | **Solution** | An active Shield malware detection rule prevents download or local editing of potentially malicious content, but preview and online editing remain available. Contact your enterprise admin to adjust the applied Shield policies. | | | | | - | - | | **Error** | `incorrect_shared_item_password` | | **Message** | | | **Solution** | A password is required for the shared item, but it was either incorrect or not supplied. | | | | | - | - | | **Error** | `storage_limit_exceeded` | | **Message** | Account storage limit reached | | **Solution** | The storage limit of the account has been reached. Either [upgrade](https://support.box.com/hc/en-us/articles/360043692774-Upgrading-your-Box-Account) your account or permanently delete content to continue. Content moved to the trash still counts towards the account total until it is permanently deleted. | | | | | - | - | | **Error** | `user_email_confirmation_required` | | **Message** | User needs to complete email confirmation | | **Solution** | The user has not yet completed [steps](https://support.box.com/hc/en-us/articles/360043691614) for email confirmation. | | | | | **Error** | `cors_origin_not_whitelisted` | | **Message** | Access denied - Did you forget to safelist your origin in the CORS configuration of your app? | | **Solution** | Your application tried to access the Box API from a website. The application needs to explicitly allow Cross Origin Resource Sharing for the domain your site is hosted on. | ### 404 Not Found | | | | - | - | | **Error** | `not_found` | | **Message** | | | **Solution** | The resource could not be found. Check the extended error message in the response body for more details. | | | | | - | - | | **Error** | `not_trashed` | | **Message** | Item is not trashed | | **Solution** | The item that is to be permanently deleted is not in the trash. Send the item to the trash first. | | | | | - | - | | **Error** | `preview_cannot_be_generated` | | **Message** | Preview cannot be generated | | **Solution** | You are not able to generate a preview thumbnail for the specified file. | | | | | **Error** | `trashed` | | **Message** | Item is trashed | | **Solution** | The item that is to be accessed is in the trash and unavailable for modification. Move the item out of the trash and try again. | ### 405 Method Not Allowed | | | | - | - | | **Error** | `method_not_allowed` | | **Message** | Method Not Allowed | | **Solution** | The HTTP method used for the API operation is not allowed. Check the API reference documentation for the HTTP verb needed for the API operation. | ### 409 Conflict | | | | - | - | | **Error** | `conflict` | | **Message** | A resource with this value already exists | | **Solution** | This error can occur when the resource to be created already exists. Check the extended error message in the response body for more details. | | | | | - | - | | **Error** | `item_name_in_use` | | **Message** | Item with the same name already exists | | **Solution** | This error is produced when a resource with the same name already exists. Ensure that the resource name being added or modified is unique. | | | | | - | - | | **Error** | `name_temporarily_reserved` | | **Message** | The item name is reserved by another processing item. Wait 60 seconds and then retry the request, or wait and check the parent folder to see if the name is in use. | | **Solution** | Two duplicate requests have been submitted at the same time. Box acknowledges the first and reserves the name, but a second duplicate request arrives before the first request has completed. The name can stay reserved for up to 60 seconds. Wait at least 60 seconds before retrying. If the first request completed, a later retry can return `item_name_in_use` instead. | | | | | - | - | | **Error** | `operation_blocked_temporary` | | **Message** | The operation is blocked by another ongoing operation | | **Solution** | This error is returned when trying to access a folder that is blocked by another folder operation, such as a move or copy. Try again at a later interval. | | | | | - | - | | **Error** | `recent_similar_comment` | | **Message** | A similar comment has been made recently | | **Solution** | A similar comment was recently made, and the API has flagged it as a potential duplicate. Verify that the comment was indeed made, or modify the comment content and try again. | | | | | - | - | | **Error** | `user_login_already_used` | | **Message** | User with the specified login already exists | | **Solution** | A user with the same email already exists. Either refer to the existing user or specify a different email. | ### 410 Gone | | | | - | - | | **Error** | `session_expired` | | **Message** | | | **Solution** | The upload session associated with the given upload session ID has expired and can no longer be accessed. | | | | | - | - | | **Error** | `upload_failed` | | **Message** | | | **Solution** | The upload session is in an unrecoverable state and cannot continue. This or other requests have resulted in the upload session reaching a bad state (for example parts overlapping). Possible situations where this can occur include when the maximum number of parts has been exceeded or when overlapping parts have been uploaded. | ### 411 Length Required | | | | - | - | | **Error** | `length_required` | | **Message** | content-length header was required, but not provided. | | **Solution** | Supply a content-length header within your API request. | ### 412 Precondition Failed | | | | - | - | | **Error** | `precondition_failed` | | **Message** | The resource has been modified. Retrieve the resource again and retry | | **Solution** | Check the extended error message in the response body for more details. | | | | | - | - | | **Error** | `sync_state_precondition_failed` | | **Message** | The resource has been modified. Retrieve the resource again and retry | | **Solution** | Check the extended error message in the response body for more details. | ### 413 Request Entity Too Large | | | | - | - | | **Error** | `request_entity_too_large` | | **Message** | Request Entity too Large | | **Solution** | This error is produced when the size of the upload is more than the allowed maximum. Check the extended error message in the response body. | ### 415 Unsupported Media Type | | | | - | - | | **Error** | `unsupported_media_type` | | **Message** | Previews for `boxnote` files are not yet supported. | | **Solution** | This error is produced when requesting an embed preview of a Box Note. Embedded previews are currently unsupported for Box Notes. | ### 429 Too Many Requests | | | | - | - | | **Error** | `rate_limit_exceeded` | | **Message** | Request rate limit exceeded, try again later. | | **Solution** | The client is performing operations too quickly and has been rate limited. Client is advised to retry their request after the amount of time specified by the `retry-after` header. There are four rate limits to be aware of. | | | | | - | - | | **Error** | `rate_limit_exceeded` | | **Message** | Your enterprise has reached its monthly AI unit quota. Try another agent, contact your admin to purchase additional units, or wait for the quota to reset. | | **Solution** | Box AI endpoints return this error when your enterprise has used all of its AI Units. The response has no `retry-after` header, and retrying doesn't succeed until the quota resets or your admin purchases more AI Units. Box SDKs retry `429` responses automatically, so check the `message` or `help_url` to tell this error apart from a rate limit and stop retrying. See Understanding Box AI usage. | ### 500 Internal Server Error | | | | - | - | | **Error** | `internal_server_error` | | **Message** | Internal Server Error | | **Solution** | Client should retry using [exponential back-off strategy](https://en.wikipedia.org/wiki/Exponential_backoff) | ### 502 Bad Gateway | | | | - | - | | **Error** | `bad_gateway` | | **Message** | | | **Solution** | Client should retry using [exponential back-off strategy](https://en.wikipedia.org/wiki/Exponential_backoff) | ### 503 Unavailable | | | | - | - | | **Error** | `unavailable` | | **Message** | Unavailable | | **Solution** | If a Retry-After header is provided in the response, the client should retry the request according to the header value. In rare situations, a write operation might eventually persist its changes after the 503 response is received by the client, so the client should handle this case upon retry. If the issue persists, check our [Status Site](https://status.box.com/) for any known outage information. | [status-codes]: http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html [articles]: https://support.box.com/hc/en-us/sections/360007552913-Troubleshooting-Box-Platform # Token & URL Expiration Source: https://developer.box.com/guides/api-calls/permissions-and-errors/expiration Across the Box API there are a few tokens, codes, and URLs that automatically expire. The following is a quick overview of their respective expiration times. | | | | - | - | | [Authorization Codes] | Expires after 30 seconds | | [Access Tokens] | Expires after 60 minutes | | [Refresh Tokens] | Expires after 60 days or 1 use | | [Download URLs] | Expires after 15 minutes | See each respective guide for more details. [Authorization Codes]: /guides/authentication/oauth2 [Access Tokens]: /guides/authentication/tokens [Refresh Tokens]: /guides/authentication/tokens/refresh [Download URLs]: /guides/downloads # Box API rate limits Source: https://developer.box.com/guides/api-calls/permissions-and-errors/rate-limits Understand Box API rate limits, 429 responses, and how to retry requests without exceeding per-user and enterprise quotas. There are three common types of API call rate limitations that Box may use at its discretion to best protect network resources and preserve the quality of our customer experience. A free developer account lets you start making API calls and test your integration's rate limit handling with real requests. ## User based These rate limits protect our service from issues that may arise when a single user generates too much traffic. The number of API calls that a user can make in a minute is limited as described below. These limits apply to all Box user accounts and are the most common. Generally, they are initiated when a user exceeds approximately 1000 API calls/minute, but certain API endpoints may have different rate limits. ## Quality of service These rate limits are designed to protect the quality of service of our infrastructure. If there is resource contention in the infrastructure, we introduce automatic rate limits to prevent system degradation and outages. For instance, if an application happens to be accessing the same physical database server, such as the use of a file migration tool accessing related resources that access the same underlying physical resources, Box may impose temporary rate-limits when load spikes and adjust them as the system recovers. ## Licensing based All Box Business Plans come with a licensed number of permitted API calls per enterprise per month. These license based rate limits are designed to prevent excessive overages and misuse of network resources. If Box's infrastructure detects that a tool used by or on behalf of a customer has exceeded that customer's API license allocation or is intending to circumvent network controls, additional selective rate-limiting may be imposed. You can see the default API allocations licensed with a particular account level at our [pricing page][pricing], but note that some customers purchase Platform API Pricing plans that increase their allocation. ## Monitor and reduce API usage Calls from custom applications, scripts, and integrations count toward your enterprise's monthly allocation, including authentication requests. Calls from Box partner integrations and native Box applications don't. For the full definition, see the Platform Activity report. To find which applications drive your usage, an admin can review the Platform Insights dashboard or run a Platform Activity report. The report lists API calls per application and whether they are chargeable. To reduce the number of API calls your application makes: * Cache access tokens and reuse them until they expire. See authentication best practices. * Request only the fields you need with the `fields` query parameter. See request extra fields. * Use webhooks or the event stream instead of polling for changes. * Use marker-based pagination with a higher `limit` to retrieve large lists in fewer requests. * Use metadata queries to find content by metadata instead of reading metadata file by file. Box AI API calls consume AI Units, which are tracked separately from API calls. See Understanding Box AI usage. ## Per API rate limits There are currently a few distinct rate limits in place within the Box API. * General API calls * 1000 API requests per minute, per user * Uploads * 240 file upload requests per minute, per user * Search * 6 searches per second, per user, to the search endpoint * Two additional limits are applied on top of the basic rate limit * 60 searches per minute, per user * 12 searches per second, per enterprise * Box Sign * Create and resend sign request: 100 requests per minute, per user * Get sign request: 1000 requests per minute, per user ## Rate limit error When an application hits a rate limit, the API will return an API response with an HTTP status code of `429 Too Many Requests`. The response will include the following headers and JSON body. ```yaml theme={null} retry-after: 100 ``` ```json theme={null} { "type": "error", "status": 429, "code": "rate_limit_exceeded", "help_url": "/guides/api-calls/permissions-and-errors/common-errors/", "message": "Request rate limit exceeded, please try again later", "request_id": "abcdef123456" } ``` Please see the Client Error resource for more details. The `retry-after` header provides guidance on the number of seconds to wait before the next API call can be retried. In general, we advise using an exponential back-off strategy for retrying API calls. ## SDK retry behavior Box's current SDKs automatically retry requests that return `429 Too Many Requests`. The retry uses an exponential back-off strategy and honors the `retry-after` header returned by the API, so you don't need to implement your own retry loop for rate-limit errors when using these SDKs. See Box SDKs for the list of supported languages and versions. If you use an older Box SDK version, a community SDK, or call the API directly (for example, with `curl`, Postman, or your own HTTP client), you are responsible for retrying `429` responses yourself. Wait for the number of seconds indicated by the `retry-after` header before your first retry, then apply exponential back-off if the request continues to fail. [pricing]: https://www.box.com/pricing # Box API scopes Source: https://developer.box.com/guides/api-calls/permissions-and-errors/scopes Configure Box application scopes in the Developer Console so your app can call only the API endpoints it needs. When an application is created in the Developer Console, the user must configure application scopes. Similar to how users have permissions to access files and folders within Box, applications have their own set of permissions to perform certain actions on behalf of a Box user or a Box enterprise. The name for a set of permissions for an application is a "scope". In short, an application's scopes determine which endpoints an application can successfully call and are reflected in the access provided by Access Tokens of the application. ## User permissions and scopes Box API scopes are the permissions you assign to an application in the Developer Console. A call succeeds only when both the app's scopes and the authenticated user's permissions allow the action. It is important to understand that even if an application has the right scopes to perform an action, the user associated with the Access Token making the call needs to have permission to perform the action as well and vice versa. For example, if your application is set up to read files, the authenticated user does need to have permission to read the file you are trying to access. To learn more about how scopes, token permissions, and user permissions work together, see our security guide. A free developer account gives you access to the Developer Console, where you can configure application scopes and start making API calls. ## Scopes & OAuth 2 authorization When sending a user through a client-side OAuth 2 flow to authorize your application it is possible to append a set of scopes to the authorization URL to further restrict the user's access token. For example, if your application has the `root_readonly` and `root_readwrite` scopes enabled, it is possible to restrict a user's access token to `root_readonly` by specifying this scope when redirecting the user. ```js theme={null} GET https://account.box.com/api/oauth2/authorize?scope=root_readonly&client_id=.... ``` When the scope parameter is omitted the application will use the scopes that were set when the application was created. ## Self-service scopes These scopes are available through the Developer Console when configuring an application. Navigate to the **Application Scopes** section of the **Configuration** tab and select one or more of the following scopes. ### Read all files and folders | | | | - | - | | **OAuth Scope** | `root_readonly` | | **Application Scope** | Read all files and folders stored in Box. | Gives an application the ability to read all the files/folders for the authenticated user. Access to content is further restricted by the users' permission and Access Token used. Although this gives an application the permission to read files and folders, the user making the API call does need to have access to the items being accessed. In the case of a JWT application accessing a Managed User's items, the Service Account's Token will need to either use the `as-user` header or create a User Access Token to directly authenticate as the user who has access to the content. ### Read and write all files and folders | | | | - | - | | **OAuth Scope** | `root_readwrite` | | **Application Scope** | Read and write all files and folders stored in Box | Gives an application write access for the authenticated user. This allows the application to upload files or new file versions, download content, create new folders, update or delete collaborations, create comments or tasks, and more. Necessary to download files and folders. Access to content is further restricted by the users' permission and Access Token used. Although this gives an application read/write access to items, the user making the API call needs to have access to the content. ### Manage users The manage users scope in the Developer Console maps to two OAuth scopes. | | | | - | - | | **OAuth Scope** | `manage_managed_users` | | **Application Scope** | Manage users | Gives an application permission to manage Managed Users. It allows the app to change the user's primary login, reset their password, and change roles for managed users. Although this allows an application to manage users, for client-side applications, the Access Token used must be associated with an Admin or Co-Admin with the correct permissions. Additionally, for JWT applications, the application must be configured with **App Access + Enterprise Access** application access. | | | | - | - | | **OAuth Scope** | `manage_app_users` | | **Application Scope** | Manage users | Gives an application permission to manage App Users, which means this scope only applies to server-side authenticated (JWT) applications. ### Manage groups | | | | - | - | | **OAuth Scope** | `manage_groups` | | **Application Scope** | Manage groups | Gives an application permission to manage an enterprise's groups. It allows the app to create, update, and delete groups, as well as manage group membership. Although this allows an application to manage groups, for client-side applications, the Access Token used must be associated with an Admin or Co-Admin with the correct permissions. For JWT applications, groups the app creates itself can be managed with **App Access Only**. To manage groups that were not created by the app itself, the application must be configured with **App Access + Enterprise Access** application access. ### Manage webhooks | | | | - | - | | **OAuth Scope** | `manage_webhook` | | **Application Scope** | Manage webhooks | Gives an application permission to create webhooks for a user. Please review webhook limitations. Most notably, there is a limit of 1000 webhooks per application, per user. ### Manage enterprise properties | | | | - | - | | **OAuth Scope** | `manage_enterprise_properties` | | **Application Scope** | Manage enterprise properties | Gives an application permission to view the enterprise event stream, as well as view and edit the enterprise's attributes and reports. It also allows the application to edit and delete device pins. Although this allows an application to manage enterprise properties, for client-side applications, the Access Token used must be associated with an Admin or Co-Admin with the correct permissions. For example, to update a Shield list with the Update shield list endpoint, associate the Access Token with the primary admin, or with a co-admin who can manage Shield configurations. ### Manage retention policies | | | | - | - | | **OAuth Scope** | `manage_data_retention` | | **Application Scope** | Manage retention policies | | **Depends on** | `enterprise_content`-scope | Gives an application permission to view and create retention policies with Box Governance. This requires the enterprise to have purchased [Box Governance][governance]. This scope also requires the `enterprise_content` scope to function properly. These scopes can be requested by opening a ticket via our support channels. ### Manage signature requests | | | | - | - | | **OAuth Scope** | `sign_requests.readwrite` | | **Application Scope** | Manage signature requests | Gives an application permission to get, create, cancel, and resend sign requests. This scope requires the application to also have read/write scopes, which are automatically selected when enabled. In addition, an enterprise must have Sign enabled. ### Manage Box AI API | | | | - | - | | **OAuth Scope** | `ai.readwrite` | | **Application Scope** | Manage AI | Gives an application permission to send requests to Box AI API. ### Manage Box Relay | | | | - | - | | **OAuth Scope** | `manage_triggers` | | **Application Scope** | Manage Box Relay | Gives an application permission to interact with Box Relay endpoints and start flows of type `WORKFLOW_MANUAL_START`. This scope requires the application to also have read/write scopes. ## Available on request There are some additional scopes that are only available upon request. To do so, please submit a ticket to our [support team](/support). They will review these requests on an individual basis and only provide approval if the use case requires the scope. It is not possible to request extra scopes if your account is a free trial account. Before filing a support request for activation of the following scopes, log in to your paid enterprise account or [upgrade your free developer account][pricing] to an enterprise account tier. ### Manage Legal Holds | | | | - | - | | **OAuth Scope** | `manage_legal_holds` | | **Depends on** | `enterprise_content`-scope | Gives an application permission to create, view, edit, and delete legal hold policies and their assignments, apply policies to content, and manage file version retentions. For use with the Governance add-on. This scope depends on the `enterprise_content` scope to function properly. This scope can be requested by opening a ticket via our support channels. ### Suppress email notifications | | | | - | - | | **Application Scope** | Can suppress email notifications from API calls | Allows some types of email notifications to be suppressed when API calls are made. ### Global Content Manager (GCM) | | | | - | - | | **OAuth Scope** | `enterprise_content` | | **Application Scope** | Global Content Manager | Allows Admins, [Co-Admins][ca], and Service Accounts to retrieve any content they do not own or are not collaborators on within their enterprise, based on their enterprise settings. This scope is required to manage the retention policies and legal holds. **Side effects** Enabling this scope on an application changes the behavior of some API calls, and most notably, makes it impossible to write content without explicitly authenticating as a user using the `as-user` header. Additionally, enabling this scope disables accessing content that is owned by users in another enterprise. For this reason, this scope will not be provisioned unless absolutely necessary. ## Scopes for downscoping In some cases an Access Token needs to be downscoped to a more strict permission level, especially when a token needs to be exposed to a client-side, public environment like a browser. The primary example for this is when using [Box UI Elements][ui-elements], which require an Access Token in the user's browser. The following is a list of **additional** scopes that can be used with the `POST /oauth2/token` endpoint to downscope an existing access token. | OAuth Scope | UI Element affected | Description | | - | - | - | | `annotation_edit` | Preview | Create, edit, and delete annotations on a specific file, and view your own annotations on it. | | `annotation_view_all` | Preview | View annotations from all users on a specific file. | | `annotation_view_self` | Preview | View only the authenticated user's own annotations on a specific file. | | `base_explorer` | Explorer | Access content in the folder tree based on user/file/token permissions. | | `base_picker` | Picker | Access content in the folder tree based on user/file/token permissions. | | `base_preview` | Preview | Preview the file only. | | `base_sidebar` | Sidebar | Get basic file info needed for the sidebar UI element. | | `base_upload` | Uploader | Upload into the folder specified under `resource` when downscoping the token. | | `item_delete` | Explorer | Delete files, folders, and file versions, including permanently deleting items from trash. Applies only to the item the downscoped token was created for. | | `item_download` | Explorer, Preview | Download files or a folder's content. | | `item_preview` | Explorer | Preview a file. | | `item_rename` | Explorer | Rename files and folders. | | `item_share` | Explorer, Picker | Share the item specified under `resource` of the token exchange. | | `item_upload` | Picker | Upload in the content picker. | The standard OAuth scopes are also supported when downscoping. | OAuth Scope | Description | | - | - | | `ai.readwrite` | Send requests to Box AI API. | | `manage_managed_users` | Create, view, edit, and delete managed users, including changing a user's login, resetting their password, and assigning co-admin permissions. Also grants management of any managed user's content in the enterprise. | | `manage_app_users` | Create, view, edit, and delete app users, which are accounts created and owned by your application. For use with server-side authentication. Also grants the ability to activate and deactivate users, and the enterprise-wide user-listing permissions required to enumerate app users. | | `manage_data_retention` | Create, view, edit, and delete retention policies and their assignments, and remove file version retentions. For use with the Governance add-on. | | `manage_enterprise` | Broad administrative access to enterprise settings, user administration, admin event logs, group tags, and device pins. Grants a complete superset of both Manage users and Manage groups, plus co-admin permission assignment, content management for any user, terms of service management, and sandbox management. | | `manage_enterprise_properties` | Manage enterprise-level settings other than users and groups: enterprise attributes, admin event logs, device pins, enterprise feature settings (view and edit), terms of service, and the collaboration domain allowlist. Also grants view access to SSO settings and app authorizations, and the ability to manage sandboxes, manage platform apps, create automation users, create enterprise authorizations, and sign agreements. Requires App + Enterprise Access. | | `manage_groups` | Create, view, edit, and delete groups, manage group membership, and invite groups to collaborate. | | `manage_webhook` | Create, view, edit, and delete webhooks, and send notifications when content changes. Limited to 1000 webhooks per application, per user. | | `sign_requests.readwrite` | Interact with Box Sign endpoints. | [console]: https://app.box.com/developers/console [ui-elements]: https://github.com/box/box-ui-elements [pricing]: https://www.box.com/pricing/platform [governance]: https://www.box.com/security/governance-and-compliance [ca]: https://support.box.com/hc/en-us/articles/1500005433721-Users-Groups-Settings#h_01GSE1DYJKTY9EXEWJEDKFHCNV # Versioning errors Source: https://developer.box.com/guides/api-calls/permissions-and-errors/versioning-errors Box provides versioning capabilities for selected API endpoints. The version control system guarantees seamless functioning of existing endpoint versions, even if Box introduces new ones. API versioning empowers Box to continually enhance its platform, while also offering third-party developers a reliable avenue for feature updates and deprecations. To stay informed about the API modifications, monitor the [Changelog](/changelog) and maintain a current email address in the **App Info** section of the Developer Console. ## Error examples When using versioned API calls, you can encounter versioning-related errors. This reference lists the most common cases when errors appear and provides you with examples of such errors. ## Calling with incorrect `box-version` header If you call an API using an incorrect `box-version` header, the API will respond with an `HTTP error code 400 - Bad Request` error and provide the supported versions in the response message. The response will include one of the following status messages in `message` field: | Details | Message | | - | - | | `box-version` value is an unsupported API version or was sent malformed. | `Invalid API version specified in 'box-version' header.` | | The request headers did not include `box-version` header when versioned only endpoint was called. | `Missing required box-version header.` | | `box-version` is empty. | `Invalid (empty) API version specified in 'box-version' header.` | | `box-version` contained multiple versions. It requires **only one** version per request. | `The 'box-version' header supports only one header value per request, do not use comas.` | | An unsupported API version is used for an existing endpoint. | `Unsupported API version specified in 'box-version' header.` | An example of a response with an incorrect `box-version` header: ```json theme={null} { "type": "error", "status": 400, "code": "invalid_api_version", "help_url": "/reference/error-codes/invalid-api-version", "message": "Invalid API version specified in 'box-version' header. Supported API versions: [2024.0].", "request_id": "abcdef123456" } ``` ## Calling an incorrect API version in the URL Box documentation specifies API URLs. For instance, the Sign Requests endpoints are accessed via: `https://api.box.com/2.0/sign_requests/`. If you mistakenly make a call to an incorrect version, such as `https://api.box.com/3.0/sign_requests/`, the response returns an `HTTP error code 404 - Not Found` error. ## Calling a deprecated API When you use an API version that Box has marked as deprecated, the API will respond as usual. Additionally, it will append a `Deprecation` header, stating the deprecation date. For example: ```sh theme={null} Deprecation: date="Fri, 11 Nov 2026 23:59:59 GMT" Box-API-Deprecated-Reason: /reference/deprecated ``` You should monitor API responses to verify if the `Deprecation` header is present to accordingly plan the transition to a new API version. ## Calling a non-existent version If you attempt to use an outdated API version, such as `2025.0` which has reached its end-of-life, the response will return an `HTTP error code 404 - Not Found`. See [Calling an incorrect API version in the URL](#calling-an-incorrect-api-version-in-the-url) for more information. # Request extra fields Source: https://developer.box.com/guides/api-calls/request-extra-fields Learn about standard, mini, and full resource variants in the Box API, and how to use the fields query parameter to request additional fields. The number of fields returned for a resource depends on the API endpoint used to request the resource. ## Use the `fields` query parameter To request a specific field for a resource that is not returned by default in the standard response, append the `fields` query parameter to your request. The value of this parameter is a comma separated list of field names. ```sh theme={null} curl https://api.box.com/2.0/files/12345?fields=is_package,lock \ -H "authorization: Bearer ACCESS_TOKEN" ``` ```json theme={null} { "etag": "1", "id": "12345", "is_package": false, "lock": null, "type": "file" } ``` It is important to note that when a specific field is requested no other fields are returned except for those requested and the **base** set of fields. For a file, this base set is comprised of the `etag`, `id`, and `type` values. ## Resource variants The following resource variants are available in the Box API. ### Standard The default set of fields returned in an API response. The standard variant is returned when requesting a resource through the main APIs available for that resource. For example, when requesting the `GET /files/:id` endpoint the API will return the standard variation of a file. ```sh theme={null} curl https://api.box.com/2.0/files/12345 \ -H "authorization: Bearer ACCESS_TOKEN" ``` ```json theme={null} { "content_created_at": "2019-06-20T06:04:41-07:00", "content_modified_at": "2019-06-20T06:04:41-07:00", "created_at": "2019-06-20T07:28:42-07:00", "created_by": { "id": "191919191", "login": "joe@example.com", "name": "Joe Box", "type": "user" }, "description": "", "etag": "1", "file_version": { "id": "56663434454334", "sha1": "585afa5209bbd586c79499b7336601341ad06cce", "type": "file_version" }, "id": "12345", ... "size": 65000647, "trashed_at": null, "type": "file" } ``` ### Mini Where a resource is returned as a nested part of another response it is often reduced in size, only returning some of the more essential fields. This variant is commonly known as the mini resource variant. For example, when requesting the `GET /folders/:id/items` endpoint the API will return a mini variation of files and folders nested within the `item_collection`. ```sh theme={null} curl https://api.box.com/2.0/folders/12345/items \ -H "authorization: Bearer ACCESS_TOKEN" ``` ```json theme={null} { "id": "0", "type": "folder", "item_collection": { "entries": [ { "etag": "1", "file_version": { "id": "56663434454334", "sha1": "585afa5209bbd586c79499b7336601341ad06cce", "type": "file_version" }, "id": "12345", "name": "Video.mp4", "sequence_id": "1", "sha1": "585afa5209bbd586c79499b7336601341ad06cce", "type": "file" } ... ] ... } ... } ``` To request more information for a nested resource we recommend calling the API for that resource to request it by ID, and optionally pass along the `fields` query parameter. For example, to get the owner of a file returned when listing the items in a folder, request that file by ID with the query parameter `fields=owned_by`. ### Full The total set of fields that can be returned in an API response. The full variant is returned when requesting a resource through the main APIs available for that resource and by appending the `fields` query parameter. For example, when requesting the `GET /files/:id` endpoint with the `fields=is_package,lock` parameter the API will return the fields specified plus the basic fields for the file. ```sh theme={null} curl https://api.box.com/2.0/files/12345?fields=is_package,lock \ -H "authorization: Bearer ACCESS_TOKEN" ``` ```json theme={null} { "etag": "1", "id": "12345", "is_package": false, "lock": null, "type": "file" } ``` # Sorting responses Source: https://developer.box.com/guides/api-calls/sorting Where an API returns a collection of items it often supports sorting of API responses. Use the `sort` and `direction` query parameters to sort the collection either in ascending or descending order. ```sh theme={null} curl https://api.box.com/2.0/folders/0/items?sort=size&direction=DESC \ -H "authorization: Bearer ACCESS_TOKEN" ``` Not all API endpoints that return collections have support for sorting. Especially endpoints that use marker-based pagination often lack support for sorting the results. ## Sorting criteria The field to sort on is defined by the `sort` query parameter. Check the API endpoint's documentation for the possible options for this value. In some APIs the `sort` field is the second criteria by which the items are sorted. For example for the `GET /folders/:id/items` endpoint the results are always sorted by their type first before any other criteria. ## Sorting direction The sorting direction supports two values, either `ASC` for ascending order, or `DESC` for the reverse. # Status codes Source: https://developer.box.com/guides/api-calls/status-codes The following rules can be applied to interpret the HTTP status codes received when using the Box API. | HTTP Status | | | - | - | | `200-299` | Box received, understood, and accepted the API request. The request has either completed or is in the process of being completed. | | `300-399` | Box received, understood, and accepted the API request, yet the client must take further action in order to complete the request. Often this includes redirect to other URLs. | | `400-499` | A client error occurred when handling the request, often because the client either did not provide the right parameters, did not have access to the resources, or tried to perform an action that is otherwise not possible. | | `500-599` | Box received and accepted the request, but an error occurred within Box while handling it. These errors signify a problem with Box, not a problem with the client's request | # Suppress notifications Source: https://developer.box.com/guides/api-calls/suppress-notifications For some API calls, you can block email and webhook notifications by including a `box-notifications: off` header with the API call. ```sh cURL theme={null} curl -X POST https://api.box.com/2.0/folders \ -H "box-notifications: off" \ -H "authorization: Bearer ACCESS_TOKEN" \ -d '{ "name": "New Folder", "parent": { "id": "0" } }' ``` As an example, this can be used for a virus-scanning tool to download copies of every user's files in an enterprise without every collaborator on the file receiving an email informing them of the download. All actions will still appear in users' updates feed and the audit-logs. **Scope requirement** Notification suppression is available for approved applications only. Contact support to request the required scopes to be enabled for your application. The following settings need to be configured for your application for this feature to properly work. * **Can suppress email notifications from API calls** - available on request via support * **Manage Enterprise Properties** - available via the developer console * Co-admin permissions of **Edit settings for your company**. Some notifications can not be suppressed, most notably the creation of users, comments, collaborations, task assignments, and when changing a user's login. # Types and formats Source: https://developer.box.com/guides/api-calls/types-and-formats The following sections explain some basic concepts about the types and formats that can be encountered within the Box APIs. ## Requests The Box APIs use JSON in the request bodies. There are a few notable exceptions to this rule: * The `POST /oauth2/token` is used to request access tokens and as per the OAuth 2.0 specification it accepts the body to be sent with a content type of `application/x-www-form-urlencoded`. * Most of the APIs that are used to upload binary data, like the `POST /files/content` endpoint, expect data to be sent as form data with a content type of `multipart/form-data`. Although not required, we highly recommend passing a header with each API request to define the content type of the data sent, for example `content-type: application/json`. ### Headers As per the HTTP specification, all request header names in the Box API are case-insensitive and can be provided in lowercase, uppercase, or any mixed case form. In other words, the content type header can be set as `CONTENT-TYPE: application/json`, `content-type: application/json`, `content-type: application/json` or even the slightly absurd `cOnTeNt-TyPe: application/json`. Header values **are** mostly case sensitive unless stated otherwise. ### GZip compression By default data sent from Box is not compressed. To improve bandwidth and response times it's possible to compress the API responses by including an `Accept-Encoding: gzip, deflate` request header. ### Date and times The Box APIs support [RFC 3339][rfc3339] timestamps. The preferred way to format a date in a request is to convert the time to UTC, for example `2013-04-17T09:12:36-00:00`. In those cases where timestamps are rounded to a given day, the time component can be omitted. In this case, `2013-04-17T13:35:01+00:00` would become `2013-04-17`. In those cases where timestamps support millisecond precision the expected request format should be as follows `2013-04-17T09:12:36.123-00:00`. The timezone can differ between different files and folders because an enterprise's timezone can change over time. A common example is daylight saving time. Items created during standard time would have a different timezone than items created during daylight saving time. For this reason it's important to use an `RFC3339`-compliant date-time parser to handle dates returned by the API. Timestamps are restricted to dates after the start of the Unix epoch, `00:00:00 UTC` on January 1, 1970. ## Responses The Box APIs generally return JSON in the response body. There are a few notable exceptions to this rule as well. * APIs that delete items return an empty body with a `204 No Content` HTTP status code. * APIs used to request binary data either return a `200 OK` status code with the binary data attached, or a `202 Accepted`, or `302 Found` status code with no body and a `location` header pointing to the actual binary file. The `content-type` response header can be used to understand the type of content returned in the API. Additionally, every API endpoint has its response type documented in our API reference documentation. ### Headers As per the HTTP specification, all response header names in the Box API are case-insensitive and could change over time. This means that the API might return responses with a content type header of `CONTENT-TYPE: application/json`, `content-type: application/json` or `content-type: application/json`. Ideally your application should convert header names to a standard case upon request and then use that standardized set of headers to look up values of the headers. Header values **are** always case sensitive unless stated otherwise. ### Resources Most standard API responses where only one resource is returned follow the following format. ```json theme={null} { "id": "12345", "type": "folder", ... } ``` Every one of these resources will always return an ID and the type of the resource. ### Collections Where an API response returns multiple items a collection is returned. Although the exact format of these collections can change from endpoint to endpoint they generally are formatted as follows. ```json theme={null} { "total_count": 5000, "limit": 1000, "offset": 2000, "order": [ { "by": "type", "direction": "ASC" } ], "entries": [ { "id": 12345, "etag": 1, "type": "file", "sequence_id": 3, "name": "Contract.pdf" } ] } ``` | Field | Always present? | | | - | - | - | | `entries` | Yes | A list of entries in the collection | | `total_count` | No | The total numbers in the collection that can be requested. This can be larger than this page of results | | `limit` | No | For endpoints that support offset-based pagination, this specifies the limit to the number of results returned | | `offset` | No | For endpoints that support offset-based pagination, this specifies the offset of results returned | | `order` | No | For endpoints that support sorting, this specifies the order the results are returned in | | `next_marker` | No | For endpoints that support marker-based pagination, this specifies the marker for the next page that can be returned | | `prev_marker` | No | For endpoints that support marker-based pagination, this specifies the marker for the previous page that can be returned | ### Request IDs When your API call returns in an error, our API will return an error object with a `request_id` field. ```json theme={null} { "type": "error", "status": 400, "code": "item_name_invalid", "help_url": "/guides/api-calls/permissions-and-errors/common-errors/", "message": "Method Not Allowed", "request_id": "abcdef123456" } ``` When reaching out to support about a specific error, please provide the full API response including the `request_id` to help our support team to quickly find your request. Most API calls also return a `box-request-id` response header. The value of this header should not be confused with the `request_id` value in the body of an error response. ### Large numbers In some cases the API can return extremely large numbers for a field. For example, a folder's size might have grown to many terabytes of data and as a result the `size` field of the folder might have grown to a very large number. In these cases these numbers are returned in [IEEE754][numbers] format for example `1.2318237429383e+31`. [numbers]: https://en.wikipedia.org/wiki/IEEE_754 [rfc3339]: https://www.ietf.org/rfc/rfc3339.txt # Applications Source: https://developer.box.com/guides/applications/index Box Developer Console allows you to create applications you can then use to integrate with Box. **My Platform Apps** view displays a list of already created applications and gives you quick access to their configuration details. This way, you don't need to open the app each time you want to generate a Developer Token, copy the Client ID, or generate a report. ## Features **My Platform Apps** page allows you to: * Search through the list of already created apps. * Filter the apps by **Enablement Status** and **Authentication Type**. * Create a new app. * Copy the app's Client ID. * Rename the app and access its details with one click. * Check application enablement and authorization status. Apps published to Integrations display status from Integrations. The **Options menu** available for every entry allows you to: * Access the configuration details of your application. * Generate a Developer Token. * Add collaborators to your application. * Run the Platform App Diagnostics Report. ## Platform App Insights Admins and co-admins can access the Platform Insights dashboard that provides a comprehensive view of the organization’s platform usage. This includes app-related data, such as: * The total number of API calls per application. * A list of top applications within the enterprise. * A list of pending application approvals. * A list of applications awaiting enablement. See [Platform Insights][insights] for details. You need the following permissions to access and view Platform Insights: * View settings and apps for your company * Edit settings and apps for your company * Run new reports and access existing reports [insights]: https://support.box.com/hc/en-us/articles/20738406915219-Platform-Insights # Integrations Source: https://developer.box.com/guides/applications/integrations/index [Box Integrations][app-center] is the first place for Box users to find out about applications they can use in combination with Box. If your application can be used by other enterprises, listing your service under **Integrations** can be a great way to find new users. Integrations group apps into sections so that you can quickly find featured, most popular, or recently added apps. Integrations ## Developing a platform app or becoming a Box Partner If you need more information on developing a platform app for the Box Integrations or becoming a Box Partner, visit our [Box Partner Resources][bp] guides on our community site. ## Publishing a platform app Use the following steps to publish a platform app in Box Integrations. ### Prerequisites Your application must meet the following requirements: * The platform app is in a finished state and ready for production usage. * The platform app leverages OAuth 2.0 authentication, as Integrations do not support any other authentication methods. * You are a developer with access to the platform app in the **Developer Console**. ### Steps 1. Navigate to the Developer Console > **My Platform Apps** and select the app you want to publish. 2. Select the **Publishing** tab from the top menu. Publishing tab for an application 3. Read through the submission checklist and check the confirmation checkbox if your app meets all the requirements. 4. Fill in the form by providing the following details: * The categories your app falls under * A short and a long description * The URL for the **Add** button * Screenshots and an app icon * Supplementary information to support users 5. Use the **Preview** button in the top right corner to see how your application will look when listed. 6. Finally, submit the application for approval by clicking the **Submit for Approval** button. Once a request for approval is received, the Box Partner team will be notified and review your request as soon as possible. For any questions, email [`integrate@box.com`][email]. ## Unpublishing a platform app Once approved and published, a platform app can be unpublished from the same control panel: 1. Navigate to the **Developer Console** and select your platform app. 2. Select the **Publishing** tab. 3. You can now unpublish the app. [app-center]: https://app.box.com/services [email]: mailto:integrate@box.com [bp]: https://support.box.com/hc/en-us/sections/21356597387539-Box-Partner-Programs # Create a Platform App Source: https://developer.box.com/guides/applications/platform-apps/create A Platform App allows for interaction with our 150+ endpoints. For example, downloading/uploading, searching, applying metadata and more. ## Prerequisites Access to the [Developer Console][dev-console]. ## Create a Platform App 1. Navigate to the [Developer Console][dev-console]. 2. Click **New App**. 3. Select an app type: **User** for apps where users link their Box accounts, or **Server** for backend services infrastructure. 4. If you selected **Server**, you may also be asked to choose an authentication method (see below for more information). 5. Click **Create**. For **Server** apps, Client Credentials Grant is always the default. The **Switch server app auth type (CCG or JWT)** setting in **Admin Console > Enterprise Settings > Platform Apps** controls whether the method is locked: * When switching is **enabled** (the default for free developer accounts), the app is created with Client Credentials Grant and you can change it to JWT - or back - afterward. * When switching is **disabled** (the default for enterprises), the dialog shows a **Select Method** step with Client Credentials Grant preselected. You have the option to pick JWT at creation instead. The method is then fixed for the life of the app. See Choosing between CCG and JWT for guidance on picking the method, and Switch between CCG and JWT for how to change it later. ## Configure application settings After you create a Platform App, the settings screen is displayed. ### General settings * **App Name** - the name you set up during the app creation, you can change it here if needed. * **App Description** - provide a description for your app (optional). * **Contact Email** - this is set to the developer of the application by default. Keep in mind that once you publish your app, this email is publicly visible to Box users who view your app in the Integrations. We recommend changing it to a support email address, so that users can reach out to support in case of any issues with the integration. ### Configuration * **Purpose** - select the purpose of your app from the drop-down list. Depending on the option you choose, you might need to specify further details. | Purpose | Details | | - | - | | **Automation**, **Custom Portal** | Specify if the app is built by a customer or partner. | | **Integration** | Specify the integration category, external system name if you're integrating with one, and if the app is built by a customer or partner. | | *Other* | Specify the app purpose and if it is built by a customer or partner. | * **Authentication Method** - how your app authenticates to the Box APIs. | App type | Auth method | Details | | - | - | - | | **User Authentication** | OAuth 2.0 | Specify the client ID and client secret. | | **Server Authentication** | Client Credentials Grant or JWT | Chosen during app creation or set in the **Configuration** tab, depending on the **Switch server app auth type (CCG or JWT)** enterprise setting. See Switch between CCG and JWT. | * **Developer Token** - a developer token is created automatically when you create a Platform App. * **Application Scopes** - choose the scopes you want to grant to your app. See the scopes guide for detailed information on each option. * **Advanced Features** - enable the advanced features your application requires. * **CORS Domains** - add the domains you want to allow requests from. [dev-console]: https://app.box.com/developers/console # Platform App Source: https://developer.box.com/guides/applications/platform-apps/index A Platform App typically presents Box functionality to a user through a custom interface. Box offers pre-built, customizable user interface components, known as UI Elements, for functionalities like browsing, searching, and previewing content. ## Authentication methods When you create a Platform App, you select an app type: * **User**: for user-facing apps that redirect users to Box to log in. Uses OAuth 2.0. * **Server**: for backend services and automations. Uses Client Credentials Grant or JWT. Depending on your enterprise settings, you pick the method when you create the app or set it later in the **Configuration** tab. ## When to use Use a Platform App when you want to: * Use OAuth 2.0, Client Credentials Grant, or JWT for authentication. * Upload and download files * Access both your own files and files owned by managed or external users. * List the application in the Box Integrations * Provide integration into the Box Web App ## Use cases Example use cases include: * A file vault in an application that allows an end user to access files that have been shared with them, while also providing access for employees to the same files through the Box Web app. An example of this is a financial advisor sharing statements and investment prospectuses with investors that can be viewed and commented on within a platform application. * A file upload feature in an application that allows an end user to submit and upload files from within a custom-built application to Box. These uploads then initiate a business process with the Box Web app. An example of this is a candidate submitting a PDF of a resume to a recruiting portal that can then be routed to an appropriate employee for review. A free developer account gives you access to the Developer Console, where you can create Platform Apps using your preferred authentication method. ## Approval Platform Apps may require approval before use. # Create Web App Integration Source: https://developer.box.com/guides/applications/web-app-integrations/configure This guide explains how to set up a Web App Integration with a Platform App. Server-side integration is no longer supported. This means the applications using server-side actions will still be working, but you won't be able to modify the server-side configuration options such as Preliminary Callback URL or Basic Authentication. You will be able t
[...]
